' Excel-Tabelle als HTML (fuer (X)HTML schreiben V0.3; Juni 2016, Matthias Thieme
' http://www.die-thiemes.de/
' http://webblog.die-thiemes.de/
Attribute VB_Name = "usrXHTMLTabellen-V0.3"
Option Explicit

Dim iFirstRow, iFirstCol, iLastRow, iLastCol As Integer
Dim iColCount As Integer

Dim vScreenRes As Variant

Dim iTableLayout() As Integer
Dim iRowSpan() As Integer           ' verbundene Zellen zeilenweise
Dim iColSpan() As Integer           ' verbundene Zellen spaltenweise
Dim iTdCol(), iTdRow() As Integer   ' Matrix fuer colspan und rowspan im td-Element
Dim iTrRowHeight() As Integer       ' Zeilenhoehe -> per inline-style im tr-Element

Dim strCellFormat() As String
Dim iCSSformatCnt, iCSSformatLastIdx, iCSSrunVar As Integer

Public Const strCrLf = "" ' entweder vbCrLf oder leer
Public Const bTestFlag = False ' Testausgaben direkt im aktiven Tabellenblatt -> Vorsicht!

' globale Eigenschaften ...
Dim vFontSizeGlobal As String
Dim strFontNameGlobal As String
Dim strFontStyleGlobal As String
Dim strFontWeightGlobal As String

Type usrBorderItem
    vTop As Variant
    vLeft As Variant
    vBottom As Variant
    vRight As Variant
End Type

Type usrRangeFormat
    lFontColor As Long
    iFontColorIndex As Integer
    bFontBold As Boolean
    bFontItalic As Boolean
    bFontSuperscript As Boolean
    bFontSubscript As Boolean
    vTextDecoration As Variant
    vFontSize As Variant
    vFontName As Variant
    lInteriorColor As Long
    iInteriorColorIndex As Integer
    iRangePixelWidth As Integer
    dRangePointsWidth As Double
    dRangeCharsWidth As Double
    iRangePixelHeight As Integer
    dRangePointsHeight As Double
    dRangeCharsHeight As Double
    lBorderColor As Long
    vBorderColor As usrBorderItem
    vBorderColorIndex As usrBorderItem
    iBorderPixelWidth As Integer
    vBorderWeight As usrBorderItem
    strBorderLineStyle As String
    vBorderLineStyle As usrBorderItem
End Type

'**
' Excel-Tabelle als HTML (fuer (X)HTML schreiben V0.3; Juni 2016, Matthias Thieme
' http://www.die-thiemes.de/
' http://webblog.die-thiemes.de/
' ueberspringt ausgeblendete Zeilen und Spalten
' verbundene Zellen werden untersttzt
' Formatierung als inline-style in td-Elementen
'**
Sub HTML_Table_Generator(strFile As String)
Dim filenr, iRowCnt, iColCnt, ihVar, ihVar2, iMergedCellsCnt As Integer
Dim bMergedCellsRowStart As Boolean
Dim iFirstMergedRow, iFirstMergedCol, iLastMergedRow, iLastMergedCol As Integer

Dim iCntR, iCntC As Integer
Dim iCSSformatCnt As Integer

Dim strFirstAddress As String

Dim strAdresse() As String

Dim strData, hstr As String '** CSV-Datenzeile

Dim rngBereich As Range
Dim usrFormatInfo As usrRangeFormat
Dim oActiveCell As Object


filenr = FreeFile
Open strFile For Output As #filenr

    Set rngBereich = [ActiveCell].CurrentRegion
    Set rngBereich = Selection
    
    Call GetRangeFormatInfo(rngBereich, usrFormatInfo)

    ' Tabellenkopf ...
    strData = "<table border='1' cellpadding='1' cellspacing='1' style=" & Chr(34) & _
        "text-align: inherit; " & "vertical-align: inherit;" & "border-collapse: collapse;" & "border-spacing: 0;" & "width: inherit;" & _
        "border-bottom-color: #" & Application.WorksheetFunction.Dec2Hex(usrFormatInfo.vBorderColor.vBottom, 6) & ";" & _
        "border-left-color: #" & Application.WorksheetFunction.Dec2Hex(usrFormatInfo.vBorderColor.vLeft, 6) & ";" & _
        "border-right-color: #" & Application.WorksheetFunction.Dec2Hex(usrFormatInfo.vBorderColor.vRight, 6) & ";" & _
        "border-top-color: #" & Application.WorksheetFunction.Dec2Hex(usrFormatInfo.vBorderColor.vTop, 6) & ";" & _
        "border-bottom-style: " & GetLineStyle(usrFormatInfo.vBorderLineStyle.vBottom) & ";" & _
        "border-left-style: " & GetLineStyle(usrFormatInfo.vBorderLineStyle.vLeft) & ";" & _
        "border-right-style: " & GetLineStyle(usrFormatInfo.vBorderLineStyle.vRight) & ";" & _
        "border-top-style: " & GetLineStyle(usrFormatInfo.vBorderLineStyle.vTop) & ";" & _
        "border-bottom-width: " & usrFormatInfo.vBorderWeight.vBottom & "px;" & _
        "border-left-width: " & usrFormatInfo.vBorderWeight.vLeft & "px;" & _
        "border-right-width: " & usrFormatInfo.vBorderWeight.vRight & "px;" & _
        "border-top-width: " & usrFormatInfo.vBorderWeight.vTop & "px;" & _
        Chr(34) & ">" & strCrLf

    Print #filenr, strData;
    ' Spalten init ...
    strData = "<colgroup>" & vbCrLf
    For iColCnt = iFirstCol To iLastCol
        ' ausgeblendete Spalten auslassen ...
        If Columns(iColCnt).Hidden <> True Then
            ihVar = GetCellPixelWidth(Cells(1, iColCnt), 96)
            strData = strData & "<col width=" & Chr(34) & ihVar & Chr(34) & ">" & vbCrLf
        End If
    Next iColCnt
    strData = strData & "</colgroup>" & vbCrLf
    Print #filenr, strData;
    
    strData = "<tbody>" & vbCrLf
    Print #filenr, strData;
    
    '** Tabellenlayout scannen, verbundene Zellen suchen...
    '**
    For iRowCnt = iFirstRow To iLastRow
        ' ausgeblendete Zeilen auslassen ...
        If Rows(iRowCnt).Hidden <> True Then
            For iColCnt = iFirstCol To iLastCol
                ' ausgeblendete Spalten auslassen ...
                If Columns(iColCnt).Hidden <> True Then
                    iTableLayout(iRowCnt - iFirstRow, iColCnt - iFirstCol) = 0
                    
                    If Cells(iRowCnt, iColCnt).MergeCells Then
                        ' 1 in iTableLayout(zeile, spalte) bedeutet verbundene Zelle
                        iTableLayout(iRowCnt - iFirstRow, iColCnt - iFirstCol) = 1
                        strAdresse = Split(Cells(iRowCnt, iColCnt).MergeArea.Address(), "$")
                        iFirstMergedCol = Range(strAdresse(1) & "1").Column
                        iFirstMergedRow = Val(strAdresse(2))
                        iLastMergedCol = Range(strAdresse(3) & "1").Column
                        iLastMergedRow = Val(strAdresse(4))
                        If iFirstMergedCol <> iLastMergedCol Then
                            ' verbundene Zellen spaltenweise erfassen; Anzahl merken
                            iColSpan(iRowCnt - iFirstRow, iColCnt - iFirstCol) = iLastMergedCol - iFirstMergedCol + 1
        If bTestFlag Then
        Cells(iRowCnt, iColCnt + (iLastCol - iFirstCol + 2)).Value = iColSpan(iRowCnt - iFirstRow, iColCnt - iFirstCol)
        End If
                        End If
                        If iFirstMergedRow <> iLastMergedRow Then
                            ' verbundene Zellen zeilenweise erfassen; Anzahl merken
                            iRowSpan(iRowCnt - iFirstRow, iColCnt - iFirstCol) = iLastMergedRow - iFirstMergedRow + 1
        If bTestFlag Then
        Cells(iRowCnt + (iLastRow - iFirstRow + 2), iColCnt + (iLastCol - iFirstCol + 2)).Value = iRowSpan(iRowCnt - iFirstRow, iColCnt - iFirstCol)
        End If
                        End If
                    End If 'Cells(iRowCnt, iColCnt).MergeCells
                    
        If bTestFlag Then
        Cells(iRowCnt - (iLastRow - iFirstRow + 2), iColCnt + (iLastCol - iFirstCol + 2)).Value = iTableLayout(iRowCnt - iFirstRow, iColCnt - iFirstCol)
        End If
                End If 'Columns(iColCnt).Hidden <> True
            Next iColCnt
        End If 'Rows(iRowCnt).Hidden <> True
    Next iRowCnt
    ' verbundene Zellen in Zeilen suchen ...
    For iCntR = 0 To iLastRow - iFirstRow
        For iCntC = 0 To iLastCol - iFirstCol
            If iColSpan(iCntR, iCntC) = 0 Then
                iTdCol(iCntR, iCntC) = 1
            Else
                iTdCol(iCntR, iCntC) = iColSpan(iCntR, iCntC)
                ihVar = iColSpan(iCntR, iCntC)
                For ihVar2 = 1 To ihVar - 1
                    iTdCol(iCntR, iCntC + ihVar2) = 0
                Next ihVar2
                iCntC = iCntC + ihVar - 1
            End If
        Next iCntC
    Next iCntR
    ' verbundene Zellen in Spalten suchen ...
    For iCntC = 0 To iLastCol - iFirstCol
        For iCntR = 0 To iLastRow - iFirstRow
            If iRowSpan(iCntR, iCntC) = 0 Then
                iTdRow(iCntR, iCntC) = 1
            Else
                iTdRow(iCntR, iCntC) = iRowSpan(iCntR, iCntC)
                ihVar = iRowSpan(iCntR, iCntC)
                For ihVar2 = 1 To ihVar - 1
                    iTdRow(iCntR + ihVar2, iCntC) = 0
                Next ihVar2
                iCntR = iCntR + ihVar - 1
            End If
        Next iCntR
    Next iCntC
    If bTestFlag Then
    ' Testausgabe ...
    For iCntR = 0 To iLastRow - iFirstRow
        For iCntC = 0 To iLastCol - iFirstCol
            Cells(iFirstRow - (iLastRow - iFirstRow + 2) + iCntR, iFirstCol + ((iLastCol - iFirstCol) * 2 + 4) + iCntC).Value = iTdCol(iCntR, iCntC)
            Cells(iFirstRow + iCntR, iFirstCol + ((iLastCol - iFirstCol) * 2 + 4) + iCntC).Value = iTdRow(iCntR, iCntC)
        Next iCntC
    Next iCntR
    End If

    ' Tabellenbildung
    ' inline-style fuer td-Elemente bilden...
    For iRowCnt = iFirstRow To iLastRow
        ' ausgeblendete Zeilen auslassen ...
        If Rows(iRowCnt).Hidden <> True Then
            ' Zeile einleiten ...
            strData = "<tr>" & vbCrLf
            Print #filenr, strData;
            For iColCnt = iFirstCol To iLastCol
                
                ' ausgeblendete Spalten auslassen ...
                If Columns(iColCnt).Hidden <> True Then
                
                    iTableLayout(iRowCnt - iFirstRow, iColCnt - iFirstCol) = 0
                    If iTdCol(iRowCnt - iFirstRow, iColCnt - iFirstCol) * iTdRow(iRowCnt - iFirstRow, iColCnt - iFirstCol) > 0 Then
                    
                        strData = "<td " & " colspan=" & Chr(34) & iTdCol(iRowCnt - iFirstRow, iColCnt - iFirstCol) & Chr(34) & _
                            " rowspan=" & Chr(34) & iTdRow(iRowCnt - iFirstRow, iColCnt - iFirstCol) & Chr(34)
                        
                        Call GetRangeFormatInfo(Cells(iRowCnt, iColCnt), usrFormatInfo)
                        strData = strData & " style=" & _
                            Chr(34) & _
                            "border-bottom-color: #" & Application.WorksheetFunction.Dec2Hex(usrFormatInfo.vBorderColor.vBottom, 6) & ";" & _
                            "border-left-color: #" & Application.WorksheetFunction.Dec2Hex(usrFormatInfo.vBorderColor.vLeft, 6) & ";" & _
                            "border-right-color: #" & Application.WorksheetFunction.Dec2Hex(usrFormatInfo.vBorderColor.vRight, 6) & ";" & _
                            "border-top-color: #" & Application.WorksheetFunction.Dec2Hex(usrFormatInfo.vBorderColor.vTop, 6) & ";" & _
                            "border-bottom-style: " & GetLineStyle(usrFormatInfo.vBorderLineStyle.vBottom) & ";" & _
                            "border-left-style: " & GetLineStyle(usrFormatInfo.vBorderLineStyle.vLeft) & ";" & _
                            "border-right-style: " & GetLineStyle(usrFormatInfo.vBorderLineStyle.vRight) & ";" & _
                            "border-top-style: " & GetLineStyle(usrFormatInfo.vBorderLineStyle.vTop) & ";" & _
                            "border-bottom-width: " & usrFormatInfo.vBorderWeight.vBottom & "px;" & _
                            "border-left-width: " & usrFormatInfo.vBorderWeight.vLeft & "px;" & _
                            "border-right-width: " & usrFormatInfo.vBorderWeight.vRight & "px;" & _
                            "border-top-width: " & usrFormatInfo.vBorderWeight.vTop & "px;" & _
                            "color: #" & Application.WorksheetFunction.Dec2Hex(usrFormatInfo.lFontColor, 6) & ";" & _
                            "background-color: #" & Application.WorksheetFunction.Dec2Hex(usrFormatInfo.lInteriorColor, 6) & ";" & _
                            "height: " & usrFormatInfo.iRangePixelHeight & "px;" & _
                            "font-style: " & GetFontStyle(usrFormatInfo.bFontItalic) & ";" & _
                            "font-weight: " & GetFontWeight(usrFormatInfo.bFontBold) & ";" & _
                            "font-size: " & Round(usrFormatInfo.vFontSize * vScreenRes / 72) & "px;" & _
                            "font-family: " & usrFormatInfo.vFontName & ";"
                        ' Zentrierung ...
                        Call CheckCellCenterHTML(Cells(iRowCnt, iColCnt), strData)
                        
                        strData = strData & Chr(34) & ">" & vbCrLf
                        strData = strData & Replace(Trim(Cells(iRowCnt, iColCnt).Text), vbLf, "<br />")
                        strData = strData & "</td>" & vbCrLf
                        Print #filenr, strData;
                    
                    
                    End If 'iTdCol(iRowCnt - iFirstRow, iColCnt - iFirstCol) * iTdRow(iRowCnt - iFirstRow, iColCnt - iFirstCol) > 0
        
                End If 'Columns(iColCnt).Hidden <> True
            Next iColCnt
            strData = "</tr>" & vbCrLf
            Print #filenr, strData;
        End If
    Next iRowCnt

    strData = "</tbody>" & vbCrLf & "</table>" & vbCrLf
    Print #filenr, strData;
Close #filenr
End Sub

'
' bFlag = true -> erster Aufruf fuer Zelle
Private Function CheckCellCenterHTML(ByRef actCell As Object, ByRef strDat As Variant)
Dim lFarbWertLong As Long
Dim strHelp1, strHelp2 As String
    
'    If actCell.HorizontalAlignment = xlCenter Then
'        strDat = strDat & "  "
'    End If
    Select Case actCell.HorizontalAlignment
        Case xlCenter:
            strDat = strDat & "text-align: center;"
        Case xlRight:
            strDat = strDat & "text-align: right;"
        Case xlLeft:
            strDat = strDat & "text-align: left;"
        Case Else
            strDat = strDat & ""
    End Select
    Select Case actCell.VerticalAlignment
        Case xlCenter:
            strDat = strDat & "vertical-align: middle;"
        Case xlBottom:
            strDat = strDat & "vertical-align: bottom;"
        Case xlTop:
            strDat = strDat & "vertical-align: top;"
        Case Else
            strDat = strDat & ""
    End Select
End Function



'**
'** Informationen zu Zellformatierungen
'**
Function GetCellPixelWidth(ByRef rngRange As Range, ByVal iScreenResolution As Integer)
Dim vRangePoints, vRangeChars, vRangePixels As Variant
vRangeChars = 0
vRangePoints = 0
    If Not IsNull(rngRange.Width) Then
        vRangePoints = rngRange.Width
    End If
    If Not IsNull(rngRange.ColumnWidth) Then
        vRangeChars = rngRange.ColumnWidth
    End If
    vRangePixels = (vRangePoints / 72) * iScreenResolution 'pixel width of column
    GetCellPixelWidth = vRangePixels
End Function
Function GetCellPointsWidth(ByRef rngRange As Range)
Dim vRangePoints, vRangeChars, vRangePixels As Variant
vRangeChars = 0
vRangePoints = 0
    If Not IsNull(rngRange.Width) Then
        vRangePoints = rngRange.Width
    End If
    GetCellPointsWidth = vRangePoints
End Function
Function GetCellCharsWidth(ByRef rngRange As Range)
Dim vRangePoints, vRangeChars, vRangePixels As Variant
vRangeChars = 0
vRangePoints = 0
    If Not IsNull(rngRange.ColumnWidth) Then
        vRangeChars = rngRange.ColumnWidth
    End If
    GetCellCharsWidth = vRangeChars
End Function
Function GetCellPixelHeight(ByRef rngRange As Range, ByVal iScreenResolution As Integer)
Dim vRangePoints, vRangeChars, vRangePixels As Variant
vRangeChars = 0
vRangePoints = 0
    If Not IsNull(rngRange.Height) Then
        vRangePoints = rngRange.Height
    End If
    If Not IsNull(rngRange.RowHeight) Then
        vRangeChars = rngRange.RowHeight
    End If
    vRangePixels = (vRangePoints / 72) * iScreenResolution 'pixel width of column
    GetCellPixelHeight = vRangePixels
End Function
Function GetCellPointsHeight(ByRef rngRange As Range)
Dim vRangePoints, vRangeChars, vRangePixels As Variant
vRangeChars = 0
vRangePoints = 0
    If Not IsNull(rngRange.Height) Then
        vRangePoints = rngRange.Height
    End If
    GetCellPointsHeight = vRangePoints
End Function
Function GetCellCharsHeight(ByRef rngRange As Range)
Dim vRangePoints, vRangeChars, vRangePixels As Variant
vRangeChars = 0
vRangePoints = 0
    If Not IsNull(rngRange.RowHeight) Then
        vRangeChars = rngRange.RowHeight
    End If
    GetCellCharsHeight = vRangeChars
End Function

'**
'** Informationen zur Zellformatierung holen
'**
Function GetRangeFormatInfo(ByRef rngRange As Object, ByRef usrRangeFormat As usrRangeFormat)
Dim lTest As Long
If Not IsNull(rngRange.Font.Color) Then
lTest = rngRange.Font.Color
End If
    With usrRangeFormat
        If Not IsNull(rngRange.Font.Color) Then
            .lFontColor = GetColorRGBdez(rngRange.Font.Color)
        Else
            .lFontColor = 0
        End If
        
        If Not IsNull(rngRange.Font.Bold) Then
            .bFontBold = rngRange.Font.Bold
        Else
            .bFontBold = False
        End If
        If Not IsNull(rngRange.Font.Italic) Then
            .bFontItalic = rngRange.Font.Italic
        Else
            .bFontItalic = False
        End If
        
        If Not IsNull(rngRange.Font.Size) Then
            .vFontSize = rngRange.Font.Size
        Else
            .vFontSize = 11
        End If
        If Not IsNull(rngRange.Font.Name) Then
            .vFontName = rngRange.Font.Name
        Else
            .vFontName = "Arial"
        End If
        
        .vTextDecoration = GetTextDecoration(rngRange.Font)
        
        .lInteriorColor = GetColorRGBdez(rngRange.Interior.Color)
        .dRangeCharsWidth = GetCellCharsWidth(rngRange)
        .iRangePixelWidth = GetCellPixelWidth(rngRange, 96)
        .dRangeCharsHeight = GetCellCharsHeight(rngRange)
        .iRangePixelHeight = GetCellPixelHeight(rngRange, 96)
        
        .lBorderColor = GetColorRGBdez(rngRange.Borders.Color)
        With .vBorderColor
            .vBottom = GetColorRGBdez(rngRange.Borders.Item(xlEdgeBottom).Color)
            .vLeft = GetColorRGBdez(rngRange.Borders.Item(xlEdgeLeft).Color)
            .vRight = GetColorRGBdez(rngRange.Borders.Item(xlEdgeRight).Color)
            .vTop = GetColorRGBdez(rngRange.Borders.Item(xlEdgeTop).Color)
        End With
        
        .strBorderLineStyle = GetLineStyle(rngRange.Borders.LineStyle)
        With .vBorderLineStyle
            .vBottom = rngRange.Borders.Item(xlEdgeBottom).LineStyle
            .vLeft = rngRange.Borders.Item(xlEdgeLeft).LineStyle
            .vRight = rngRange.Borders.Item(xlEdgeRight).LineStyle
            .vTop = rngRange.Borders.Item(xlEdgeTop).LineStyle
        End With
        
        .iBorderPixelWidth = GetPixelWidth(rngRange.Borders.Weight)
        With .vBorderWeight
            .vBottom = GetPixelWidth(rngRange.Borders.Item(xlEdgeBottom).Weight)
            .vLeft = GetPixelWidth(rngRange.Borders.Item(xlEdgeLeft).Weight)
            .vRight = GetPixelWidth(rngRange.Borders.Item(xlEdgeRight).Weight)
            .vTop = GetPixelWidth(rngRange.Borders.Item(xlEdgeTop).Weight)
        End With
    End With
End Function

Private Function GetPixelWidth(ByVal vWeight As Variant) As Variant
    Select Case vWeight
        Case xlHairline:
            GetPixelWidth = 1
        Case xlMedium:
            GetPixelWidth = 2
        Case xlThick:
            GetPixelWidth = 4
        Case xlThin:
            GetPixelWidth = 1
        Case Else
            GetPixelWidth = 0
    End Select
End Function

Private Function GetLineStyle(ByVal vLineStyle As Variant) As Variant
    Select Case vLineStyle
        Case xlContinuous:
            GetLineStyle = "solid"
        Case xlDash:
            GetLineStyle = "dashed"
        Case xlDashDotDot:
            GetLineStyle = "dotted"
        Case xlDot:
            GetLineStyle = "dotted"
        Case xlDouble:
            GetLineStyle = "double"
        Case xlLineStyleNone:
            GetLineStyle = "none"
        Case xlSlantDashDot:
            GetLineStyle = "groove"
        Case Else
            GetLineStyle = "none"
    End Select
End Function

Private Function GetColorRGBdez(ByVal lColor As Long) As Long
Dim strHelp1, strHelp2 As String
Dim lFarbwert As Long
    strHelp1 = Hex(lColor)
    strHelp1 = Application.WorksheetFunction.Dec2Hex(lColor, 6)
    strHelp2 = Mid(strHelp1, 5, 2) & Mid(strHelp1, 3, 2) & Mid(strHelp1, 1, 2)
    lFarbwert = Application.WorksheetFunction.Hex2Dec(strHelp2)
    GetColorRGBdez = lFarbwert
End Function

Private Function GetFontStyle(ByVal bStyleFlag As Boolean) As String
    If bStyleFlag Then
        GetFontStyle = "italic"
    Else
        GetFontStyle = "normal"
    End If
End Function

Private Function GetFontWeight(ByVal bWeightFlag As Boolean) As String
    If bWeightFlag Then
        GetFontWeight = "bold"
    Else
        GetFontWeight = "normal"
    End If
End Function

Private Function GetTextDecoration(ByRef objFontProperty As Object) As Variant
Dim vTxtDecoration As Variant
Dim bFlag As Boolean
    bFlag = True
    vTxtDecoration = ""
    If Not IsNull(objFontProperty.Strikethrough) Then
        If objFontProperty.Strikethrough Then
            vTxtDecoration = "line-through"
            bFlag = False
        End If
    End If
    If Not IsNull(objFontProperty.Underline) Then
        Select Case objFontProperty.Underline
            Case xlUnderlineStyleNone:
                If bFlag Then
                    vTxtDecoration = "none"
                End If
            Case xlUnderlineStyleSingle:
                If bFlag Then
                    vTxtDecoration = "underline"
                Else
                    vTxtDecoration = vTxtDecoration & " " & "underline"
                End If
            Case xlUnderlineStyleDouble:
                If bFlag Then
                    vTxtDecoration = "underline"
                Else
                    vTxtDecoration = vTxtDecoration & " " & "underline"
                End If
            Case xlUnderlineStyleSingleAccounting:
                If bFlag Then
                    vTxtDecoration = "underline"
                Else
                    vTxtDecoration = vTxtDecoration & " " & "underline"
                End If
            Case xlUnderlineStyleDoubleAccounting:
                If bFlag Then
                    vTxtDecoration = "underline"
                Else
                    vTxtDecoration = vTxtDecoration & " " & "underline"
                End If
            Case Else
            
        End Select
    End If
    GetTextDecoration = vTxtDecoration
End Function
